<?php
/*
    Plugin Name: WP Content Negotiator
    Plugin URI: http://www.admiraljustin.net/wpxml
    Description: Plugin that allows for content negotiation, providing xhtml in the proper mime type for browsers that can handle it, falling back to text/html for those that can not.
    Author: Admiral Justin
    Version: 0.2
    Author URI: http://www.admiraljustin.net/
*/

    // if you would like to check to see what the MIME type is in a script, you can check it as $GLOBALS['wp_con_mime']
    // True is app/x+x
    // False is text/html

    function wp_con_neg_header ($xml_active = "")
    {
          if ( stristr($_SERVER["HTTP_ACCEPT"],"application/xhtml+xml") )
          {
               header('Content-Type: application/xhtml+xml');
               printf('<?xml version="1.0" encoding="utf-8"?>'."\n");
               printf('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">'."\n");
               $GLOBALS['wp_con_mime'] = TRUE;
          }
          else
          {
               header('Content-Type: text/html');
               printf('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'."\n");
               $GLOBALS['wp_con_mime'] = FALSE;
          }
    }
    add_action('content_neg', 'wp_con_neg_header');

?>
